﻿Imports Word = Microsoft.Office.Interop.Word

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For r As Integer = 1 To 10
            DataGridView1.Rows.Add(New Object() {"dgv1:r" & r.ToString & "c1", "r" & r.ToString & "c2", "r" & r.ToString & "c3", "r" & r.ToString & "c4", "r" & r.ToString & "c5"})
        Next
        For r As Integer = 1 To 10
            DataGridView2.Rows.Add(New Object() {"dgv2:r" & r.ToString & "c1", "r" & r.ToString & "c2", "r" & r.ToString & "c3", "r" & r.ToString & "c4", "r" & r.ToString & "c5"})
        Next
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' Create Word Application
        Dim oWord As Word.Application = DirectCast(CreateObject("Word.Application"), Word.Application)

        ' Create new word document
        Dim oDoc As Word.Document = oWord.Documents.Open(IO.Path.Combine(My.Application.Info.DirectoryPath, "Ok then here.docx"))
        oWord.Visible = True

        'Bookmarks are "grid1" (relates to DataGridView1), + "grid2" (relates to DataGridView2)
        Dim dgvs(,) As Object = {{DataGridView1, "grid1"}, {DataGridView2, "grid2"}}

        For x As Integer = 0 To dgvs.GetUpperBound(0)
            Dim headers = (From ch In DirectCast(dgvs(x, 0), DataGridView).Columns _
                                  Let header = DirectCast(DirectCast(ch, DataGridViewColumn).HeaderCell, DataGridViewColumnHeaderCell) _
                                  Select header.Value).ToArray()
            Dim headerText() As String = Array.ConvertAll(headers, Function(v) v.ToString)

            Dim items() = (From r In DirectCast(dgvs(x, 0), DataGridView).Rows _
                  Let row = DirectCast(r, DataGridViewRow) _
                  Where Not row.IsNewRow _
                  Select (From cell In row.Cells _
                      Let c = DirectCast(cell, DataGridViewCell) _
                      Select c.Value).ToArray()).ToArray()

            Dim table As String = String.Join(vbTab, headerText) & Environment.NewLine
            For Each a In items
                Dim t() As String = Array.ConvertAll(a, Function(v) v.ToString)
                table &= String.Join(vbTab, t) & Environment.NewLine
            Next
            table = table.TrimEnd(CChar(Environment.NewLine))
            Clipboard.SetText(table)

            Dim oTable As Word.Table = oDoc.Tables.Add(oDoc.Bookmarks.Item(dgvs(x, 1).ToString).Range, items.Count + 1, headers.Count)

            oTable.Range.Paste()

            'make the first row bold, fs 14 + change textcolor
            oTable.Rows.Item(1).Range.Font.Bold = &H98967E
            oTable.Rows.Item(1).Range.Font.Size = 14
            oTable.Rows.Item(1).Range.Font.Color = Word.WdColor.wdColorWhite

            'change backcolor of first row
            oTable.Rows.Item(1).Range.Shading.Texture = Word.WdTextureIndex.wdTextureNone
            oTable.Rows.Item(1).Range.Shading.ForegroundPatternColor = Word.WdColor.wdColorAutomatic
            oTable.Rows.Item(1).Range.Shading.BackgroundPatternColor = Word.WdColor.wdColorPaleBlue

            'set table borders
            With oTable.Range.Tables(1)
                With .Borders(Word.WdBorderType.wdBorderLeft)
                    .LineStyle = Word.WdLineStyle.wdLineStyleSingle
                    .LineWidth = Word.WdLineWidth.wdLineWidth100pt
                    .Color = Word.WdColor.wdColorAutomatic
                End With
                With .Borders(Word.WdBorderType.wdBorderRight)
                    .LineStyle = Word.WdLineStyle.wdLineStyleSingle
                    .LineWidth = Word.WdLineWidth.wdLineWidth100pt
                    .Color = Word.WdColor.wdColorAutomatic
                End With
                With .Borders(Word.WdBorderType.wdBorderTop)
                    .LineStyle = Word.WdLineStyle.wdLineStyleSingle
                    .LineWidth = Word.WdLineWidth.wdLineWidth100pt
                    .Color = Word.WdColor.wdColorAutomatic
                End With
                With .Borders(Word.WdBorderType.wdBorderBottom)
                    .LineStyle = Word.WdLineStyle.wdLineStyleSingle
                    .LineWidth = Word.WdLineWidth.wdLineWidth100pt
                    .Color = Word.WdColor.wdColorAutomatic
                End With
                With .Borders(Word.WdBorderType.wdBorderHorizontal)
                    .LineStyle = Word.WdLineStyle.wdLineStyleSingle
                    .LineWidth = Word.WdLineWidth.wdLineWidth050pt
                    .Color = Word.WdColor.wdColorAutomatic
                End With
                With .Borders(Word.WdBorderType.wdBorderVertical)
                    .LineStyle = Word.WdLineStyle.wdLineStyleSingle
                    .LineWidth = Word.WdLineWidth.wdLineWidth050pt
                    .Color = Word.WdColor.wdColorAutomatic
                End With
                .Borders(Word.WdBorderType.wdBorderDiagonalDown).LineStyle = Word.WdLineStyle.wdLineStyleNone
                .Borders(Word.WdBorderType.wdBorderDiagonalUp).LineStyle = Word.WdLineStyle.wdLineStyleNone
                .Borders.Shadow = False
            End With

        Next

    End Sub

End Class
